/* ؽʤɤ¸ǡ١ */
#ifndef _record_h_included_
#define _record_h_included_

/* Patched by G-HAL, Thu,23 Oct,2008 */
#if !defined(__STDC_LIMIT_MACROS)
# define	__STDC_LIMIT_MACROS
#endif
#include <stdint.h>

#include "anthy/settings.h"		/* Patched by G-HAL, Fri,17 Oct,2008 */

/*
 * ǡ١̾ʣsection鹽ƥ
 * ʸ򥭡Ȥƹ®˼ФȤǤrowʤ롣
 *
 * ǡ١ϥsection䥫rowʤɤξ֤
 * ϤФƹԤ롣
 * sectionrowϽطäƤ
 * νطȤ̤LRUνäƤ
 */

#include "xstr.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * sectionꤹ
 * name: section̾
 * create_if_not_exist: sectionʤк뤫ɤΥե饰
 * ֤:  0  -1
 * Ԥλˤϥsection̵ˤʤ
 * ˥row̵ˤʤ
 */
#if 0	/* Patched by G-HAL, Fri,17 Oct,2008 */
int anthy_select_section(const char *name, int create_if_not_exist);
#else
extern int anthy_select_section( const enum ANTHY_SECTIONS_ section, int flag );
#endif

/*
 * section椫namerow򥫥rowˤ
 * name: row̾
 * create_if_not_exist: rowʤк뤫ɤΥե饰
 * ֤:  0  -1
 * Ԥλˤϥrow̵ˤʤ
 */
int anthy_select_row(xstr *name, int create_if_not_exist);
extern int anthy_select_row_with_learn( const xstr* const idx, int create_if_not_exist, int force_countup );	/* Patched by G-HAL, Sat,23 Aug,2008, Tue,03 Feb,2009 */

/*
 * section椫name˺ǤĹʸǥޥå
 * ̾row򥫥rowˤ
 * name: row̾
 * ֤:  0  -1
 * ԤλˤϤ˥row̵ˤʤ
 */
int anthy_select_longest_row(xstr *name);

/*
 * sectionκǽrow򥫥rowˤ
 * ֤:  0  -1
 * Ԥλˤϥrow̵ˤʤ
 */
int anthy_select_first_row(void);

/*
 * rowμrow򥫥rowˤ
 * ֤:  0  -1
 * rowФѹäƤ⡢եˤ¸ʤ
 * Ԥλˤϥrow̵ˤʤ
 */
int anthy_select_next_row(void);

/*
 * section
 * ˥section,row̵ˤʤ
 */
void anthy_release_section(void);

/*
 * sectionLRUꥹȤƬcountİʹߤ
 * ˥row̵ˤʤ
 */
/* void anthy_truncate_section(int count);*/	/* Patched by G-HAL, Sat,23 Aug,2008 */


/* ߤrowФ */
xstr *anthy_get_index_xstr(void);
int anthy_get_nr_values(void);
int anthy_get_nth_value(int );
extern int64_t anthy_get_nth_int64( int nth );			/* Patched by G-HAL, Wed,22 Oct,2008 */
xstr *anthy_get_nth_xstr(int );/* internƤxstr֤ */
extern int anthy_get_row_frequency( void );			/* Patched by G-HAL, Tue,04 Nov,2008 */
extern anthy_time_t anthy_get_row_timestamp( void );	/* Patched by G-HAL, Tue,04 Nov,2008 */

void anthy_set_nth_value(int nth, int val);
extern void anthy_set_nth_int64( int nth, int64_t val );	/* Patched by G-HAL, Wed,22 Oct,2008 */
void anthy_set_nth_xstr(int nth, xstr *xs);/* ǥԡ */

void anthy_truncate_row(int nth);/* To Be Implemented */

/*
 * row롣λΥrow
 * ˥row̵ˤʤ
 */
void anthy_release_row(void);

/*
 * row򵼻
 */
extern void anthy_pseudorelease_row( void );	/* Patched by G-HAL, Sat,17 Jan,2009 */

/*
 * rowȿؽ
 */
extern void anthy_unlearn_row( void );	/* Patched by G-HAL, Tue,30 Dec,2008 */

/*
 * rowLRUƬؤäƤ
 * ˥row̵ˤʤ
 */
int anthy_mark_row_used(void);


void anthy_reload_record(void);

#ifdef __cplusplus
}
#endif

#endif
